from rf_methods import rec_bisection, rec_regula_falsi, iter_bisection, \
    iter_regula_falsi
from Dual_Numbers import Dual_Number
from typing import Callable
import numpy as np


# def f(x: Dual_Number) -> float:
#     return ((x * x - 1) * Dual_Number.exp(x - 1)).d
#
#
# def g(x: Dual_Number) -> float:
#     return (Dual_Number.sin(x * x) + Dual_Number.exp(x + 3) *
#             Dual_Number.cos(5 - x)).d
#
#
# def h(x: Dual_Number) -> float:
#     return Dual_Number.cos(x)

# def g(x: Dual_Number) -> float:
#     return (Dual_Number.sin(x * x) + Dual_Number.exp(x * 3) *
#             Dual_Number.cos(x - 1)).d


# def dhdx(x: float) -> float:
#     return h(Dual_Number(x, 5))


# def dgdx(x: float) -> float:
#     return g(Dual_Number(x, 1))


# g(x) = x*x*exp( ln( x*x*x*x + 2 ) * sin(x) + 1 )
# def g(x: Dual_Number) -> float:
#     return (x * x * Dual_Number.exp(Dual_Number.log(x * x * x * x + 2) * Dual_Number.sin(x) + 1)).d


# def h(x: Dual_Number) -> float:
#     return g(2 * x - 0)


# def dgdx(x: float) -> float:
#     return g(Dual_Number(x, 1))


# def dhdx(x: float) -> float:
#     return h(Dual_Number(x, 1))


def A(x: Dual_Number, y: Dual_Number) -> float:
    return (3 * (x * x) * y + 2 * x * (y * y) - x * y + 2 * x - 1).d


def B(x: Dual_Number, y: Dual_Number, z: Dual_Number) -> float:
    return (x * y * z + x * x + y * y).d


def C(x: Dual_Number, y: Dual_Number, z: Dual_Number) -> float:
    return (x * Dual_Number.exp(y * y + z * z)).d


def D(x: Dual_Number, y: Dual_Number) -> float:
    return (Dual_Number.sin(x) * Dual_Number.cos(y) + Dual_Number.sin(y) * Dual_Number.cos(x)).d


def grad2D(x: float, y: float, func: Callable[[Dual_Number, Dual_Number], float]) -> tuple[float, float]:
    return (func(Dual_Number(x, 1), y), func(x, Dual_Number(y, 1)))


def grad3D(x: float, y: float, z: float, func: Callable[[Dual_Number, Dual_Number, Dual_Number], float]) -> tuple[float, float, float]:
    return (func(Dual_Number(x, 1), y, z), func(x, Dual_Number(y, 1), z), func(x, y, Dual_Number(z, 1)))


if __name__ == "__main__":
    print(f"3x²y + 2xy² − xy + 2x − 1, P = (1, 1)\t∇ = {grad2D(1, 1, A)}")
    print(f"xyz + x² + y², P = (0, 1, -1)\t∇ = {grad3D(0, 1, -1, B)}")
    print(f"xe^(y² + z²), P = (1, 1, 1)\t∇ = {grad3D(1, 1, 1, C)}")
    print(
        f"sin(x)cos(y) + sin(y)cos(x), P(π / 4, π / 4)\t∇ = {grad2D(np.pi / 4, np.pi / 4, D)}")
    # print(delZdelx(0, 1, -1))
    # print(delZdely(0, 1, -1))
    # print(delZdelz(0, 1, -1))
    # Example for f(x)
    # start = -6
    # stop = -1

    # Example for g(x)
    # start = -2
    # stop = 0.1

    # Example for g(x)
    # start = -5
    # stop = 9

    # start = -1
    # stop = -0.8
    # start = 3.5
    # stop = 5.5

    # print(f"dhdx = {dhdx(np.pi)}")

    # print("----------------------------------------------")
    # print(f"Rec bisection = {rec_bisection(start, stop, dfdx, False)}")
    # print("----------------------------------------------")
    # print(f"Rec regula falsi = {rec_regula_falsi(start, stop, dfdx, False)}")
    # print("----------------------------------------------")
    # print(f"Iter bisection = {iter_bisection(start, stop, dfdx, False)}")
    # print("----------------------------------------------")
    # print(f"Iter regula falsi = {iter_regula_falsi(start, stop, dfdx, False)}")
    # print(f"Iter regula falsi = {iter_regula_falsi(start, stop, dgdx, False)}")
    # print("----------------------------------------------")
    # print(f"Iter bisection = {iter_bisection(start, stop, dgdx, False)}")
    #
    # print(f"Iter regula falsi = {iter_regula_falsi(start, stop, dhdx, False)}")
    # print("----------------------------------------------")
    # print(f"Iter bisection = {iter_bisection(start, stop, dhdx, True)}")
