import numpy as np


def ex5():
    M = np.array([[1, 2], [-3, 4], [-5, -6]])
    N = np.array([[-1, 0, 1], [2, -2, 0]])
    v = np.array([3, -1, 5])

    print(M)
    print(N)

    # x = 1, y = 1 (aka 0, 0) of m
    print(f"1, 1 of m = {M[0][0]}")

    # Shape
    print(f"M.shape = {M.shape}")
    print(f"N.shape = {N.shape}")
    print(f"v.shape = {v.shape}")

    print(f"M * N = {M @ N}")
    print(f"N * M = {N @ M}")

    # Testing different dot or matrix products

    # 3x1 3x2 => should not exist; v will be adjusted so that matmul will work
    # (v from 3x1 to 1x3)
    print(f"v * M = {v @ M}")

    # will not work even after adjusting v
    # print(f"v * N = {v @ N}")

    # will not work even after adjusting v
    # print(f"M * v = {M @ v}")

    # will work (3x2 X 3x1)
    print(f"N * v = {N @ v}")

    # will work: 1x3 X 3x2 => 1x2 X 2x3 => 1x3
    print(f"v * M * N = {v @ M @ N}")

    # will not work: 1x3 X 2x3 => will fail
    # print(f"v * N * M = {v @ N @ M}")

    # will work: 3x2 X 2x3 => 3x3 X 3x1 => 3x1
    print(f"M * N * v = {M @ N @ v}")

    # will fail: 2x3 X 3x2 => 2x2 X 3x1 => fail
    # print(f"N * M * v = {N @ M @ v}")

    print(f"M^T = {np.transpose(M)}")
    print(f"N^T = {np.transpose(N)}")
    print(f"(M * N)^T = {np.transpose(M @ N)}")
    print(f"N^T * M^T = {np.transpose(N) @ np.transpose(M)}")

    print(f"np.identity(3) = {np.identity(3)}")
    print(f"np.diag([1, 2, 3]) = {np.diag([1, 2, 3])}")
    print(f"np.diag(M) = {np.diag(M)}")
    print(f"np.diag(N) = {np.diag(N)}")
    print(f"np.diag(N @ M) = {np.diag(N @ M)}")

    # mdr, jsp ce qui se passe
    print(f"v^T * v = {np.transpose(v) @ v}")
    print(f"v * v^T = {v @ np.transpose(v)}")


if __name__ == "__main__":
    ex5()
