import numpy as np
import math
import matplotlib.pyplot as plt
from rf_methods import iter_bisection, iter_regula_falsi
from Dual_Numbers import Dual_Number


def f(x: float) -> float:
    # return np.sin(x) + np.exp(-x) / 10
    return np.sinh(x) - np.cos(x)


def f1(x: float) -> float:
    # return np.cos(x) - np.exp(-x) / 10
    return np.cosh(x) + np.sin(x)


def f2(x: float) -> float:
    # return -np.sin(x) + np.exp(-x) / 10
    return np.sinh(x) + np.cos(x)


def f3(x: float) -> float:
    # return -np.cos(x) - np.exp(-x) / 10
    return np.cosh(x) - np.sin(x)


def f4(x: float) -> float:
    # return np.sin(x) + np.exp(-x) / 10
    return np.sinh(x) - np.cos(x)


def f5(x: float) -> float:
    # return np.cos(x) + np.exp(-x) / 10
    return np.cosh(x) + np.sin(x)


def f6(x: float) -> float:
    # return np.cos(x) + np.exp(-x) / 10
    return np.sinh(x) + np.cos(x)


def T(x: float, a: float) -> float:
    return (f(a) / math.factorial(0) * pow(x - a, 0)) + (f1(a) / math.factorial(1) * pow(x - a, 1)) + (f2(a) / math.factorial(2) * pow(x - a, 2)) + (f3(a) / math.factorial(3) * pow(x - a, 3)) + (f4(a) / math.factorial(4) * pow(x - a, 4)) + (f5(a) / math.factorial(5) * pow(x - a, 5)) + (f6(a) / math.factorial(6) * pow(x - a, 6))


if __name__ == "__main__":
    x_eval_point = 1
    start = -3
    stop = 3
    x_axis = np.arange(start, stop, 0.01)
    y_eval_point = f(x_eval_point)

    print(f"Zéros de la fonction f = {iter_bisection(start, stop, f, True)}")

    plt.figure(figsize=(8, 6))
    plt.xlim(start, stop)
    plt.ylim(-5, 5)
    plt.plot(x_axis, f(x_axis), label='g(t) = sinh(t) - cos(t)')
    plt.plot(x_axis, T(x_axis, x_eval_point),
             label='Polynôme de Taylor de degré 6')
    plt.plot(x_eval_point, y_eval_point, marker="o", markerfacecolor="purple")
    plt.legend()
    plt.xlabel('x')
    plt.ylabel('y')
    plt.title('Polynôme de Taylor de degré 6 pour g(t)')
    plt.grid(True)
    plt.show()
