import numpy as np
import matplotlib.pyplot as plt

# Définir la fonction f(x)


def f(x):
    return np.sin(x) + np.exp(-x)


# Définir le point de développement a
a = 2

# Calcul des dérivées de f(x) jusqu'au cinquième degré


def f_prime(x): return np.cos(x) - np.exp(-x)
def f_double_prime(x): return -np.sin(x) + np.exp(-x)
def f_triple_prime(x): return -np.cos(x) - np.exp(-x)
def f_4th_prime(x): return np.sin(x) - np.exp(-x)
def f_5th_prime(x): return np.cos(x) + np.exp(-x)


# Évaluez ces dérivées en a
f_a = f(a)
f_prime_a = f_prime(a)
f_double_prime_a = f_double_prime(a)
f_triple_prime_a = f_triple_prime(a)
f_4th_prime_a = f_4th_prime(a)
f_5th_prime_a = f_5th_prime(a)

# Calculez le polynôme de Taylor de degré 5


def taylor_poly(x):
    return (
        f_a +
        f_prime_a * (x - a) +
        (f_double_prime_a / 2) * (x - a)**2 +
        (f_triple_prime_a / 6) * (x - a)**3 +
        (f_4th_prime_a / 24) * (x - a)**4 +
        (f_5th_prime_a / 120) * (x - a)**5
    )


# Créez un tableau de valeurs x entre -5 et 9
x = np.linspace(-5, 9, 400)

# Calculez les valeurs correspondantes du polynôme de Taylor
taylor_values = taylor_poly(x)

# Tracez le graphique de f(x) et du polynôme de Taylor
plt.figure(figsize=(8, 6))
plt.plot(x, f(x), label='f(x) = sin(x) + exp(-x)')
plt.plot(x, taylor_values, label='Polynôme de Taylor de degré 5')
plt.legend()
plt.xlabel('x')
plt.ylabel('y')
plt.title('Polynôme de Taylor de degré 5 pour f(x)')
plt.grid(True)
plt.show()
